
#include "losing.h"
#include <pthread.h>
#include <unistd.h>

static char LOGNAME[64];
static boolean TryInput()
{fd_set fd[1]; struct timeval tv[1]; FD_ZERO(fd); FD_SET(STDIN_FILENO,fd);
 tv->tv_sec=tv->tv_usec=0; return select(STDIN_FILENO+1,fd,NULL,NULL,tv)>0;}

static void NANO(int x)
{struct timespec TS[1]; TS->tv_sec=0; TS->tv_nsec=x; nanosleep(TS,NULL);}

static uint64 RANDOM64()
{uint32 x=(uint32) random(),y=(uint32) random(),z=(uint32) random();
 x&=0x1fffff; y&=0x1fffff;
 return (((uint64) (x)) | (((uint64) (y))<<21) | (((uint64) (z))<<42));}

static void vary_hash(typePOS *POS,uint64 Z)
{int u; for (u=0;u<=POS->DYN->rev;u++) (POS->DYN-u)->HASH^=Z;}

static tWIN *WINTREE=NULL;
static void process_winloss(typePOS *POS,int id,PN_NODE *tree,uint32 n,char *S)
{uint32 u,sz; do_wintree(POS,tree,n,WINTREE);
 if (S[0] && S[strlen(S)-1]==' ') S[strlen(S)-1]=0; // remove final space
 sz=6*(WINTREE->WIN[0].data&0x3fffffff)+2*(WINTREE->WIN[0].move);
 printf("winloss %d %d %d %d %s\n",id,tree[n].good,tree[n].bad,sz,S);
 fflush(stdout);
 fwrite(&(WINTREE->WIN[0].data),4,1,stdout);
 fwrite(&(WINTREE->WIN[0].move),2,1,stdout);
 for (u=0;u<(WINTREE->WIN[0].move);u++) fwrite(&(WINTREE->ML[u]),2,1,stdout);
 for (u=1;u<(WINTREE->WIN[0].data&0x3fffffff);u++)
 {fwrite(&(WINTREE->WIN[u].data),4,1,stdout); WINTREE->WIN[u].data=0;
  fwrite(&(WINTREE->WIN[u].move),2,1,stdout);}
 WINTREE->WIN[0].data=0; fflush(stdout);}

static boolean do_output(typePOS *POS,int id,PN_NODE *tree,uint32 n,char *S)
{char N[8],T[8192]; int mv; uint32 c; // ignore Wh loss and Bl win (poss rep)
 if ((POS->wtm && !tree[n].bad) || (!POS->wtm && !tree[n].good))
 {process_winloss(POS,id,tree,n,S); return FALSE;}
 c=tree[n].child; while (c) // have seen T > 256 in length (was buff overflow)
 {strcpy(T,S); mv=tree[c].move; strcat(T,Notate(N,tree[c].move));
  printf("result %d %d %d %s\n",id,tree[c].good,tree[c].bad,T);
  fflush(stdout); c=tree[c].sibling;}
 c=tree[n].child; while (c)
 {strcpy(T,S); mv=tree[c].move; strcat(T,Notate(N,tree[c].move));
  if ((!POS->wtm && !tree[c].bad) || (POS->wtm && !tree[c].good))
  {MakeMove(POS,mv); process_winloss(POS,id,tree,c,T); UnmakeMove(POS,mv,1);}
  c=tree[c].sibling;}
 printf("flush\n"); fflush(stdout); return TRUE;}

static void bump_node(typePOS *POS,int id,PN_NODE *tree,uint32 n,char *S)
{char N[8],T[8192]; uint32 c; boolean b;
 b=do_output(POS,id,tree,n,S); c=tree[n].child; strcpy(T,S);
 while (b && c && tree[c].size>BUMP_RATIO*tree[n].size)
 {strcat(T,Notate(N,tree[c].move)); strcat(T," "); MakeMove(POS,tree[c].move);
  b=do_output(POS,id,tree,c,T); n=c; c=tree[n].child;}}

pthread_mutex_t OUTPUT_MUTEX[1];
#define LOCK_OUTPUT() pthread_mutex_lock(OUTPUT_MUTEX)
#define UNLOCK_OUTPUT() pthread_mutex_unlock(OUTPUT_MUTEX)
#define INIT_OUTPUT() pthread_mutex_init(OUTPUT_MUTEX,NULL)

static uint32 SEARCH_SIZE=1000000;
static void silent_searchA(typePOS *POS,int id,PN_NODE *tree)
{uint64 Z=RANDOM64(); vary_hash(POS,Z); pn_search(tree,POS,SEARCH_SIZE,TRUE);
 vary_hash(POS,Z); LOCK_OUTPUT(); bump_node(POS,id,tree,1,"");
 printf("retire %d\n",id); fflush(stdout); UNLOCK_OUTPUT();}

static pthread_t SPAWN_THREAD[64];
static char INP[64][4096]; static int ID[64];
static volatile boolean DIE=FALSE; static int RUN=0;
static volatile uint64 WORK=0;
pthread_mutex_t WORK_LOCK[1];
#define LOCK_WORK() pthread_mutex_lock(WORK_LOCK)
#define UNLOCK_WORK() pthread_mutex_unlock(WORK_LOCK)
#define INIT_WORK() pthread_mutex_init(WORK_LOCK,NULL)

static void do_search(char *A)
{char B[64]; int b,u; sscanf(A,"%s",B); b=atoi(B); A+=strlen(B)+1;
 LOCK_WORK(); u=BSF(~WORK); WORK|=1ULL<<u; strcpy(INP[u],A); ID[u]=b;
 UNLOCK_WORK();}

static void new_wintree(uint64 sz,uint64 hsz,uint64 lsz)
{uint32 u; if (WINTREE) {free(WINTREE->TRANS); free(WINTREE->WIN);
                         free(WINTREE->LIST); free(WINTREE);}
 WINTREE=malloc(sizeof(tWIN)); WINTREE->WIN=malloc(sizeof(WIN_NODE)*sz);
 WINTREE->LIST=malloc(sizeof(uint32)*lsz);
 WINTREE->TRANS=malloc(sizeof(tTRANS)*hsz); WINTREE->MASK=hsz-1;
 for (u=0;u<hsz;u++) WINTREE->TRANS[u].key=0;
 for (u=0;u<sz;u++) WINTREE->WIN[u].data=0;}

void* spawn_go(void *x)
{char ML[4096]; typePOS POS[1]; PN_NODE *tree; int u,s,id;
 memset((void*) POS,0,sizeof(typePOS));
 POS->ZTAB=CALLOC((HASH_MASK+1),sizeof(HASH));
 POS->DYN_ROOT=CALLOC(256+MAX_PLY,sizeof(typeDYNAMIC));
 tree=CALLOC((2*MAX_PLY+1024+SEARCH_SIZE),sizeof(PN_NODE));
 while (TRUE)
 {while (!WORK) {if (DIE) goto END; NANO(10000000);}
  LOCK_WORK(); if (!WORK) {UNLOCK_WORK(); continue;}
  u=BSF(WORK); id=ID[u]; WORK&=~(1ULL<<u); strcpy(ML,INP[u]); UNLOCK_WORK();
  s=strlen(ML); ML[s]=ML[s+1]=ML[s+2]=ML[s+3]=0;
  POS->DYN=POS->DYN_ROOT+1; init_position(POS,"startpos");
  parse_moves(POS,ML); silent_searchA(POS,id,tree);}
 END: NANO(1000000000); free(POS->ZTAB); free(tree); return NULL;}

static int CPUS=0;
static void start_thr()
{int u; RUN=CPUS;
 for (u=0;u<CPUS;u++) pthread_create(&SPAWN_THREAD[u],NULL,spawn_go,NULL);}

static void stop_thr()
{int u; DIE=1; for (u=0;u<RUN;u++) pthread_join(SPAWN_THREAD[u],NULL); DIE=0;}

static void thread_start() {stop_thr(); start_thr();}

static void new_cores(int c) {CPUS=c; thread_start();}
static void new_mem(int c)
{SEARCH_SIZE=c*1000000; HASH_MASK=(1<<BSR(SEARCH_SIZE))-1; thread_start();}
static void new_time(int c) {TIME_LIMIT=c*1.0;}

static void do_params(char *A)
{int i; char B[64],X[64],Y[64],Z[64]; strcpy(B,A);
 for (i=0;i<strlen(B);i++) if (B[i]=='/') B[i]=' ';
 sscanf(B,"%s %s %s",X,Y,Z);
 new_cores(atoi(X)); new_mem(atoi(Y)); new_time(atoi(Z));
 new_wintree(SEARCH_SIZE,2<<BSR(SEARCH_SIZE),SEARCH_SIZE);}

static void process(char *A)
{A[strlen(A)-1]=0; if (!memcmp(A,"params ",7)) do_params(A+7);
 if (!memcmp(A,"search ",7)) do_search(A+7);}

static void do_input()
{FILE *F; char A[4096]; fgets(A,4000,stdin);
 if (1) {F=fopen(LOGNAME,"a"); fwrite(A,1,strlen(A),F); fflush(F); fclose(F);}
 process(A);
 if (!strcmp(A,"quit")) {printf("quitted\n"); fflush(stdout); exit(1);}}

static void init_stuff()
{INIT_WORK(); INIT_OUTPUT(); srandom((uint32) Now()); magic_mult_init();
 setvbuf(stdin,NULL,_IONBF,0); setvbuf(stdout,NULL,_IONBF,0);
 init_tb_stuff(); load_tbs(FLAT_DIR); printf("slaveready\n");}

int main()
{sprintf(LOGNAME,"/tmp/DUMP.%d",getpid()); init_stuff(); fflush(stdout);
 while (TRUE) {NANO(10000000); if (TryInput()) do_input();}}
