
#include "losing.h"

static void LoadNodeZ(FILE *F,PN_NODE *P,uint32 w)
{fread(&(P->good),4,1,F); fread(&(P->bad),4,1,F); fread(&(P->size),4,1,F);
 fread(&P->hash,8,1,F); fread(&(P->trans),4,1,F); fread(&(P->loop),4,1,F);
 fread(&(P->parent),4,1,F); fread(&(P->sibling),4,1,F);
 fread(&(P->child),4,1,F); fread(&(P->move),2,1,F);
 fread(&(P->killer),1,1,F); fread(&(P->flags),1,1,F); P->killer=0;} 

static PN_NODE* LoadBookZ(char *fn,typePOS *POS)
{PN_NODE P[1],*T; uint32 u,sz,all; FILE* F; char A[64];
 F=fopen(fn,"r"); if (!F) {strcpy(A,"BOOKS/"); strcat(A,fn); F=fopen(A,"r");}
 if (!F) {printf("File %s not found\n",fn); exit(1);}
 LoadNodeZ(F,P,0); sz=P->size; printf("BOOK %s has %d pos\n",fn,sz);
 all=2<<BSR((8192+sz*3)/2); if (all<(1<<20)) all=(1<<20);
 T=CALLOC(all,sizeof(PN_NODE)); T[0].size=sz;
 for (u=1;u<sz;u++) LoadNodeZ(F,T+u,u); fclose(F); return T;}

WIN_STRUCT* try_wintree(PN_NODE *T,typePOS *POS,char *ml,uint16 *SKIP);
void wintree_direct(typePOS *POS,char *fn);

int main(int e,char **I)
{typePOS POS[1]; WIN_STRUCT *WS; uint16 SKIP[256];
 char A[4096],STR[1024]; PN_NODE *T; magic_mult_init();
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->DYN=POS->DYN_ROOT+1;
 init_position(POS,"startpos"); SKIP[0]=0; printf("WINTREE (command line)\n");
 fflush(stdout); init_known(FALSE); T=LoadBookZ(I[1],POS);
 fgets(A,4000,stdin); A[strlen(A)-1]=0;
 if (e>2) strcpy(STR,I[2]); else strcpy(STR,"PROOFS/WINTREE.win");
 if (!memcmp(A,"wintree ",8))
 {parse_moves(POS,A+8);
  if (known_find(POS->DYN->HASH)!=-1) {wintree_direct(POS,STR); return 0;}
  WS=try_wintree(T,POS,A+8,SKIP);}
 else return 1; if (!WS) return 1;
 SaveWinTree(WS->W,WS->MOVE_LIST,WS->W[0].move,STR);
 printf("Wrote to %s, size %d\n",STR,WS->W[0].data&0x3fffffff); return 0;}
