
#include <stdio.h>
#include <stdlib.h>
#define uint32 unsigned int
#define uint16 unsigned short int
#define FROM(s) (((s) >> 6) & 077)
#define TO(s) ((s) & 077)
#define TRUE 1
#define FALSE 0

typedef struct {uint32 data; uint16 move;} WIN_NODE; // 6 bytes

WIN_NODE *WIN;

static int is_unsolved(uint16 mv)
{if ((mv!=0xfedc) && ((mv>>12)>8 || (mv>>12)==7)) return TRUE; return FALSE;}

static char* Notate(char *M,uint16 move)
{int fr,to; char c[16]="01nbrqk7"; fr=FROM(move); to=TO(move);
 if (move==0xfedc) {sprintf(M,"NULL"); return M;} // is d7 to e3
 if (move==0xedc) {sprintf(M,"NULL"); return M;} // is d7 to e3
 if ((move>>12)>8 || (move>>12)==7) move^=0xf000; // hack for unsolved proof
 sprintf(M,"%c%c%c%c",'a'+(fr&7),'1'+((fr>>3)&7),'a'+(to&7),'1'+((to>>3)&7));
 if (move&(7<<12)) sprintf (M+4,"%c",c[move>>12]); return M;}

static void procit(uint32 u)
{char N[8]; uint32 w=WIN[u].data>>30,d=WIN[u].data&0x3fffffff;
 printf("%d %s ",u,Notate(N,WIN[u].move));
 if (is_unsolved(WIN[u].move)) printf("UNSOLVED ");
 if (w==1)
 {if (d) printf("CHILD %d SIBLING %d ",u+1,d);
  else printf("CHILD %d ",u+1);}
 if (w==2) printf("TRANS %d no sibling ",d);
 if (w==3) printf("TRANS %d SIBLING %d ",d,u+1);
 if (w==0 && d!=0) printf("SIBLING %d ",d);
 if (w==0 && d==0) printf("TERMINAL ");
 printf("[%02X ",WIN[u].data&0xff); printf("%02X ",(WIN[u].data>>8)&0xff);
 printf("%02X ",(WIN[u].data>>16)&0xff);printf("%02X ",(WIN[u].data>>24)&0xff);
 printf("%02X ",WIN[u].move&0xff); printf("%02X]\n",(WIN[u].move>>8)&0xff);}

static void doit() {int u; for (u=1;u<(WIN[0].data&0x3fffffff);u++) procit(u);}

static void dump(char *S)
{int i; FILE *F; int d,s,u; uint16 ML[1024]; char N[8]; uint32 n,sz;
 F=fopen(S,"r"); if (!F) {printf("File %s not found\n",S); exit(1);}
 WIN=malloc(32); fread(&(WIN[0].data),4,1,F); fread(&(WIN[0].move),2,1,F);
 d=WIN[0].data&0x3fffffff; s=(11*d)/10+0x10000; u=WIN[0].move;
 WIN=realloc(WIN,s*sizeof(WIN_NODE)); for (i=0;i<u;i++) fread(&(ML[i]),2,1,F);
 printf("Prolog moves (%d):",u);
 for (i=0;i<u;i++) printf(" %s",Notate(N,ML[i])); printf("\n");
 for (i=1;i<d;i++) {fread(&(WIN[i].data),4,1,F); fread(&(WIN[i].move),2,1,F);}
 printf("Read %d from %s\n",d,S);
 while (fread(&n,4,1,F))
 {fread(&sz,4,1,F); printf("Node %d has subtree size %d\n",n,sz);}
 doit();}

int main(int argc,char **argv) {dump(argv[1]); return 0;}
