
#include "losing.h"

// bit 31 of data set, has trans
// bit 30 of data set, has child, or has sibling when has trans
// 10 trans, no sibling, data is trans
// 01 has child (+1), data is sibling (or zero)
// 11 trans and sibling (+1), data is trans
// [old] if data is 0x3fffffff, then UNWON, if (1U<<30) is set, has sibling
// if move>>12 is 7 or more than 8, then UNWON
 
#define SET_CHILD(A,x) (A[x].data|=(1U<<30))
#define DATA_IS_TRANS(A,x) (((A[x].data&(1U<<31)))==(1U<<31))
#define DATA_HAS_CHILD(A,x)\
  (((A[x].data&(3U<<30)))==(1U<<30) && ((A[x].data&0x3fffffff)!=0x3fffffff))
#define TRANS_AND_SIBLING(A,x) (((A[x].data&(3U<<30)))==(3U<<30))
#define DATA_GET_NODE(A,x) (A[x].data&0x3fffffff)
#define DATA_GET_NODEns(A,x) \
  (((A[x].data&0x3fffffff)!=0x3fffffff) ? A[x].data&0x3fffffff : \
   (((A[x].data&(1U<<30))==(1U<<30)) ? ((x)+1) : 0))
#define NEXT_SIBLING(A,x) ((TRANS_AND_SIBLING(A,x)) ? ((x)+1) : \
			   (DATA_IS_TRANS(A,x) ? 0 : DATA_GET_NODEns(A,x)))

static int comp(const void *x,const void *y)
{uint16 a=*((uint16*) x); uint16 b=*((uint16*) y);
 if (a>b) return 1; if (a<b) return -1; printf("BADSORT %o\n",a); return 0;}

#if 1 // fault loops
#define MakeMoveS(a,b) MakeMove(a,b)
#define STRING "FAULT LOOPS"
#else // follow loops
#define MakeMoveS(a,b) MakeMoveCheck(a,b,0)
#define STRING "FOLLOW LOOPS"
#endif

static boolean *KNOW,OK=TRUE;
static uint32 five=0,six=0,nomoves=0,nopieces=0,fics_win=0,forced=0;
static uint32 tb=0,MAX_REV=0;
static boolean NO_FAULT=FALSE,CHECK_TBS=FALSE;
static uint64 *HT;//,*HL,hlcnt=0;

static uint16 UU(uint16 mv) // 0,2,3,4,5,6,8 -> // 15,13,12,11,10,9,7
{uint16 k=mv>>12; if (mv==0xfedc) return mv;
 if (k>8 || k==7) return mv^0xf000; return mv;}

static void Verify(WIN_NODE *W,typePOS* POS,uint32 n) // make KNOW a bit array!
{uint16 mv; uint32 c,x; uint16 ML[256],MM[256];
 int t,w,k,u,pc; uint8 va; char N[64];
 pc=POPCNT(wBitboardOcc|bBitboardOcc); if (pc==5) five++; if (pc==6) six++;
 if (DATA_GET_NODE(W,n)==0x3fffffff || UU(W[n].move)!=W[n].move)
 {printf("UNWON %d %s\n",n,Notate(N,W[n].move));
  dump_path(POS); OK=FALSE; return;}
 if (DATA_HAS_CHILD(W,n))
 {c=n+1; mv=W[c].move;
  if (POS->wtm && NEXT_SIBLING(W,c)) printf("WHITE 2x %d\n",n);
  k=GenMoves(POS,ML); if (k==1) forced++;
  if (POS->wtm) {for (u=0;u<k;u++) if (ML[u]==mv) break;
                 if (u==k) {OK=0; printf("WMOVE %d %o\n",n,mv);}}
  if (!POS->wtm)
  {u=1; x=c; MM[0]=UU(mv); while ((x=NEXT_SIBLING(W,x))) MM[u++]=UU(W[x].move);
   if (u!=k) {printf("BLACK %d %d %d\n",u,k,n); printf("AT "); dump_path(POS);
              qsort(ML,k,sizeof(uint16),comp); qsort(MM,u,sizeof(uint16),comp);
	      printf("Full Move List: "); OK=0;
              for (w=0;w<k;w++) printf("%s ",Notate(N,ML[w])); printf("\n");
	      printf("Moves in Tree: ");
              for (w=0;w<u;w++) printf("%s ",Notate(N,MM[w])); printf("\n");
	      printf("Missing Moves: "); t=0;
	      for (w=0;w<k;w++)
	      {if (t<u && ML[w]==MM[t]) {t++; continue;}
	       printf("%s ",Notate(N,ML[w]));}
              printf("\n================================================\n");}
   else {qsort(ML,k,sizeof(uint16),comp); qsort(MM,u,sizeof(uint16),comp);
         for (k=0;k<u;k++) if (ML[k]!=MM[k])
	 {OK=0; printf("BMOVE %d %d %o %o\n",n,k,ML[k],MM[k]);}}}
  if (mv!=UU(mv))
  {printf("AT "); dump_path(POS);
   printf("UNWON %s\n",Notate(N,mv)); OK=0; goto SIBLINGS;}
  if (!MakeMoveS(POS,mv))
  {printf("AT "); dump_path(POS); printf("LOOP %d\n",n); OK=0; goto SIBLINGS;}
  if (POS->DYN->rev > MAX_REV) MAX_REV=POS->DYN->rev;
  if (!HT[c]) HT[c]=POS->DYN->HASH;
  if (HT[c]!=POS->DYN->HASH) {printf("HASHc %d\n",n); OK=0;}
  if (DATA_IS_TRANS(W,c)) x=DATA_GET_NODE(W,c); else x=c;
  if (!HT[x]) HT[x]=POS->DYN->HASH;
  if (HT[x]!=POS->DYN->HASH) {printf("HASHx %d\n",n); OK=0;}
  //  if (!KNOW[x]) {Verify(W,POS,x); KNOW[x]=TRUE; HL[hlcnt++]=HT[c];}
  if (!KNOW[x]) {Verify(W,POS,x); KNOW[x]=TRUE;} UnmakeMove(POS,mv,0);
 SIBLINGS:
  while ((c=NEXT_SIBLING(W,c)))
  {mv=W[c].move;
   if (mv!=UU(mv))
   {printf("AT "); dump_path(POS);
    printf("UNWON %s\n",Notate(N,mv)); OK=0; continue;}
   if (!MakeMoveS(POS,mv))
   {printf("AT "); dump_path(POS); printf("LOOP %d\n",c); OK=0; continue;}
   if (!HT[c]) HT[c]=POS->DYN->HASH;
   if (HT[c]!=POS->DYN->HASH) {printf("HASHc %d\n",n); OK=0;}
   if (DATA_IS_TRANS(W,c)) x=DATA_GET_NODE(W,c); else x=c;
   if (!HT[x]) HT[x]=POS->DYN->HASH;
   if (HT[x]!=POS->DYN->HASH) {printf("HASHx %d\n",n); OK=0;}
   //   if (!KNOW[x]) {Verify(W,POS,x); KNOW[x]=TRUE; HL[hlcnt++]=HT[c];}
   if (!KNOW[x]) {Verify(W,POS,x); KNOW[x]=TRUE;} UnmakeMove(POS,mv,0);}}
 else if (pc>4)
 {if (NO_FAULT) return; if (!POS->wtm || GenMoves(POS,ML)) goto BAD; nomoves++;
  if (!wBitboardOcc) nopieces++;
  else if (POPCNT(wBitboardOcc)<POPCNT(bBitboardOcc)) fics_win++;
  else goto BAD; return;
 BAD: printf("AT "); OK=FALSE; dump_path(POS);
  printf("FAULT %d %llx %llx %d\n",n,wBitboardOcc,bBitboardOcc,POS->wtm);
  printf("================================================\n");}
 else if (CHECK_TBS && pc<=4) // POS should not have ep, as is 4-minimal
 {if (!Get_TB_Score(POS,&va,1) || (POS->wtm && va!=1) || (!POS->wtm && va!=3))
  {printf("AT "); dump_path(POS); printf("TB %d %d\n",n,va);} tb++;}}

static void not_ok(WIN_STRUCT *WS,WIN_NODE *W) {printf("FAILURE\n");}

int main(int argc,char **argv)
{WIN_NODE *W; WIN_STRUCT *WS; uint32 c,u,trans=0,term=0; uint64 sz;
 typePOS POS[1]; memset((void*) POS,0,sizeof(typePOS)); magic_mult_init();
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->DYN=POS->DYN_ROOT+1;
 init_position(POS,"startpos"); printf ("VERIFY WIN-TREE %s\n",STRING);
 if (!strcmp(argv[1],"--nofault")) {NO_FAULT=TRUE; c=2;} else c=1;
 if (c>=argc) {printf("There is no input file\n"); return 1;}
 WS=LoadWintreeFile(argv[c],FALSE); W=WS->W; REV_LIMIT=125;
 for (u=0;u<(W[0].move);u++) MakeMove(POS,WS->MOVE_LIST[u]);
 sz=W[0].data&0x3fffffff; KNOW=malloc(sz);  // KNOW should be bit array...
 printf("Allocating %lldmb for HASH and KNOW arrays\n",(sz*9)>>20);
 HT=malloc(sz*sizeof(uint64)); for (u=0;u<sz;u++) HT[u]=KNOW[u]=0;
 // HL=malloc(sz*sizeof(uint64)); // this is not really needed
 if (argc>c+1) CHECK_TBS=TRUE; fflush(stdout);
 if (CHECK_TBS) {printf("With TBs\n"); init_tb_stuff(); load_tbs(FLAT_DIR);}
 printf("================================================\n");
 SET_CHILD(W,0); Verify(W,POS,0); // wintree lacked 0-child set! (nofault mode)
 for (u=0;u<sz;u++)
 {if (DATA_IS_TRANS(W,u)) trans++; else if (!DATA_HAS_CHILD(W,u)) term++;
  if (u && !HT[u]) printf("UNTOUCHED %d\n",u);}
 printf("tb4 %d trans %d terminal %d internal %lld forced %d\n",
	tb,trans,term,sz-trans-term,forced);
 printf("5+6 %d+%d nomoves %d nopieces %d patt %d FICS %d\nMAXREV %d\n",
	five,six,nomoves,nopieces,nomoves-nopieces,fics_win,MAX_REV);
 if (!OK) not_ok(WS,W); else printf("OK\n"); // printf("HLC %lld\n",hlcnt);
 return 0;}
