
#include "losing.h"

// bit 31 of data set, has trans
// bit 30 of data set, has child, or has sibling when has trans
// 10 trans, no sibling, data is trans
// 01 has child (+1), data is sibling (or zero)
// 11 trans and sibling (+1), data is trans
// if data is 0x3fffffff, then UNWON, if (1U<<30) is set, has sibling

#define SET_CHILD(A,x) (A[x].data|=(1U<<30))
#define DATA_IS_TRANS(A,x) (((A[x].data&(1U<<31)))==(1U<<31))
#define DATA_HAS_CHILD(A,x) (((A[x].data&(3U<<30)))==(1U<<30))
#define TRANS_AND_SIBLING(A,x) (((A[x].data&(3U<<30)))==(3U<<30))
#define DATA_GET_NODE(A,x) (A[x].data&0x3fffffff)
#define DATA_GET_NODEns(A,x) \
  (((A[x].data&0x3fffffff)!=0x3fffffff) ? A[x].data&0x3fffffff : \
   (((A[x].data&(1U<<30))==(1U<<30)) ? ((x)+1) : 0))
#define NEXT_SIBLING(A,x) ((TRANS_AND_SIBLING(A,x)) ? ((x)+1) : \
			   (DATA_IS_TRANS(A,x) ? 0 : DATA_GET_NODEns(A,x)))

static uint32 subtree_size(WIN_NODE *W,uint32 n,boolean t);

#define MILLION (0x100000)
#define COUNTED_SIZE (128*MILLION)
#define COUNTED_MASK (COUNTED_SIZE-1)

boolean UNWON; uint64 *ARR;
#define GET_ARRAY_BIT(A,x) (A[(x)>>6]&(1ULL<<((x)&0x3f)))
#define SET_ARRAY_BIT(A,x) A[(x)>>6]|=(1ULL<<((x)&0x3f))

static int is_unsolved(uint16 mv)
{if ((mv!=0xfedc) && ((mv>>12)>8 || (mv>>12)==7)) return TRUE; return FALSE;}

static void walk_tree(WIN_NODE *W,uint32 n,boolean t)
{uint32 c; if (DATA_GET_NODE(W,n)==0x3fffffff) {UNWON=TRUE; return;}
 if (is_unsolved(W[n].move)) {UNWON=TRUE; return;}
 if (t) {if (GET_ARRAY_BIT(ARR,n)) return; SET_ARRAY_BIT(ARR,n);}
 if (DATA_IS_TRANS(W,n)) {walk_tree(W,DATA_GET_NODE(W,n),t); return;}
 if (!t) {if (GET_ARRAY_BIT(ARR,n)) return; SET_ARRAY_BIT(ARR,n);}
 if (!DATA_HAS_CHILD(W,n)) return; c=n+1; walk_tree(W,c,t);
 while ((c=NEXT_SIBLING(W,c))) walk_tree(W,c,t);}

static uint32 COMPUTE_HASH(uint32 n) /* totally random (the method that is) */
{uint32 k=n*n; k+=(n>>10)^((~n)&0x3ff); k+=((n>>5)^((~n)&0x7fff))<<5;
 k+=(((~n)>>15)^(n&0x1f))<<5; k+=(n>>4)&0x55aa55; k+=((~n)>>8)&0xaa55aa;
 return k&COUNTED_MASK;}

#define SIGN(x) (((x)>0)?1:-1)
typedef struct {uint32 n; sint32 sz;} tCOUNTED;
static tCOUNTED *COUNTED;
static sint32 SUBTREE_SIZE_IS_COUNTED(WIN_NODE *W,uint32 n)
{uint32 k; while (DATA_IS_TRANS(W,n)) n=DATA_GET_NODE(W,n); k=COMPUTE_HASH(n);
 while (COUNTED[k].n)
 {if (n==COUNTED[k].n) return COUNTED[k].sz; k++; if (k==COUNTED_SIZE) k=0;}
 return 0;}
static void SAVE_SUBTREE_SIZE(WIN_NODE *W,uint32 n,sint32 ct)
{uint32 k; while (DATA_IS_TRANS(W,n)) n=DATA_GET_NODE(W,n);
 k=COMPUTE_HASH(n); while (COUNTED[k].n) {k++; if (k==COUNTED_SIZE) k=0;}
 COUNTED[k].sz=ct; COUNTED[k].n=n; if (!DATA_HAS_CHILD(W,n)) return;
 if (!NEXT_SIBLING(W,n+1)) SAVE_SUBTREE_SIZE(W,n+1,(ABS(ct)-1)*SIGN(ct));}

static uint32 subtree_size(WIN_NODE *W,uint32 n,boolean t)
{uint32 s,u,ct=0,sz=W[0].data&0x3fffffff; if (!n) return sz; sz=(sz+63)/64;
 if (DATA_GET_NODE(W,n)==0x3fffffff || is_unsolved(W[n].move)) return -1;
 while (DATA_IS_TRANS(W,n)) n=DATA_GET_NODE(W,n);
 if ((s=SUBTREE_SIZE_IS_COUNTED(W,n))) return s;
 for (u=0;u<sz;u++) ARR[u]=0; UNWON=FALSE; walk_tree(W,n,t);
 for (u=0;u<sz;u++) ct+=POPCNT(ARR[u]); if (UNWON) ct=-ct;
 SAVE_SUBTREE_SIZE(W,n,ct); return ct;}

static uint32 PROLOG_LEN;

static uint32 largest_child_size(WIN_NODE *W,int w)
{uint32 c,u,sz=0; if (DATA_IS_TRANS(W,w)) return 0; // w=DATA_GET_NODE(W,w);
 if (!DATA_HAS_CHILD(W,w)) return 0; c=w+1; sz=subtree_size(W,c,0);
 while ((c=NEXT_SIBLING(W,c))) {u=subtree_size(W,c,0); if (u>sz) sz=u;}
 return sz;}

static uint8 *SPAT;
static void spit_loop(WIN_NODE *W,typePOS *POS,int w,int sz)
{uint32 c; uint16 mv; if (DATA_IS_TRANS(W,w)) w=DATA_GET_NODE(W,w);
 if (SPAT[w]) return; SPAT[w]=1;
 if (subtree_size(W,w,0)<=sz) return; if (!DATA_HAS_CHILD(W,w)) return;
 if (largest_child_size(W,w)<=sz) {dump_path(POS); fflush(stdout); return;}
 c=w+1; mv=W[c].move; if (is_unsolved(mv)) goto LOOP;
 MakeMoveCheck(POS,mv,FALSE); spit_loop(W,POS,c,sz); UnmakeMove(POS,mv,TRUE);
LOOP: while ((c=NEXT_SIBLING(W,c)))
 {mv=W[c].move; if (is_unsolved(mv)) continue;
  MakeMoveCheck(POS,mv,FALSE); spit_loop(W,POS,c,sz); UnmakeMove(POS,mv,1);}}
// POS is necessary only for dump_path(POS)

int main(int argc,char **argv)
{WIN_STRUCT *WS; typePOS POS[1]; uint64 sz; int i;
 memset((void*) POS,0,sizeof(typePOS));
 POS->ZTAB=CALLOC(65536,sizeof(HASH)); magic_mult_init();
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->DYN=POS->DYN_ROOT+1;
 init_position(POS,"startpos"); printf ("WIN SPITTER\n"); fflush(stdout);
 WS=LoadWintreeFile(argv[1],FALSE); PROLOG_LEN=WS->W[0].move;
 if (PROLOG_LEN)
 {char N[8]; printf("prolog");
  for (i=0;i<PROLOG_LEN;i++) printf(" %s",Notate(N,WS->MOVE_LIST[i]));
  printf("\n"); fflush(stdout);}
 printf ("LOSING CHESS\n"); fflush(stdout);
 sz=WS->W[0].data&0x3fffffff; ARR=malloc(sz/8+64);
 init_position(POS,"startpos");
 SPAT=malloc(sz+256); for (i=0;i<sz;i++) SPAT[i]=0;
 COUNTED=malloc(COUNTED_SIZE*sizeof(tCOUNTED));
 for (i=0;i<COUNTED_SIZE;i++) COUNTED[i].n=COUNTED[i].sz=0;
 for (i=0;i<PROLOG_LEN;i++) MakeMove(POS,WS->MOVE_LIST[i]);
 printf ("ABOUT TO SPIT\n"); fflush(stdout);
 spit_loop(WS->W,POS,0,atoi(argv[2])); return 0;}

// Note: this program has not been tested with mv^0xf000 unsolved moves
// actually, probably it was never tested with old-style unsolveds either
// might not be best to have the counts negated? Likely outputs nonsense...
